%!octave 
%
%     FOREL
%      
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.6.4
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: forel.m,v 1.3 2014/02/08 11:08:36 mechanoid Exp $



% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval = forel(X,r),
   MAX_ITER = 100 ;
   % список изолированных точек
   U = X ;
   szU = size(U,1) ;

   % список центров кластеров
   Xc = [] ;

   while szU>0,
	  % выбрать (случайную) изолированную точку
	  ri=randperm(szU)(1);
	  xcc = U(ri,:) ;

	  % найти ближайшие к xc точки  
	  Uc = get_points(xcc,U,r);
	  szUc = size(Uc,1) ;
	  
	  if szUc > 1,
		 % строим кластер 
		 for i=1:MAX_ITER,
			xcc_prev = xcc ;
			% расчитать центр кластера
			xcc = mean(Uc) ; 
			if xcc_prev == xcc, break; endif
			% пересчитать расстояния относительно нового центра
			Uc = get_points(xcc,U,r) ;
		 endfor
		 Xc = [ Xc ; xcc ] ;
	  endif

	  % убрать обработаные точки из списка
	  U = setdiff(U,Uc,"rows");
	  szU = size(U,1) ;

   endwhile

   save('-ascii','result/Xc.txt','Xc');
   
   retval = Xc;

endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% найти точки из U, которые удалены от xc не более чем на d
function retval = get_points(xc,U,d)
   R = dist_points(U,xc) ;
   r = R - d ; 
   r = abs(r)-r ; 
   idx = find(r) ;
   retval = U(idx,:) ;
endfunction


