%!octave 
%
%     FOREL
%      
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.6.4
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: main.m,v 1.11 2014/02/09 11:32:20 mechanoid Exp mechanoid $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% загрузить точки 

X = load("data/p04a/X.txt") ;



% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

szX=size(X,1)

% количество кластеров второго уровня
k=7 

% радиус кластера первого уровня
RANGE = 0.2 ;

printf('search low level clusters\n') ;
Xc = forel(X,RANGE) ;

% устанавливаем глубину рекурсии для алгоритма обхода дерева
max_recursion_depth( size(Xc,1)+1 ) ;

printf('search hight level clusters\n') ;
R = build_dist_matrix(Xc) ;
G = knp(R) ;

printf('plot full graph\n') ;
plot_graph(X,Xc,G,RANGE,0) ;

G = remove_long_edges(G,R,k) ;

printf('plot short graph\n') ;
plot_graph(X,Xc,G,RANGE,1) ;
 
printf('build data structures\n') ;
S = separate_clusters(G,Xc,X) ;

printf('build distance matrix\n');
R = build_dist_matrix(X) ;
printf('check quality\n') ;
q = quality_clusters_forel(R,S) ;
%q=[ 0 0 ];

printf('plot points\n') ;
plot_data(X) ;
plot_clusters(X,S,q) ;

