%!octave 
%
%     FOREL
%      
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.6.4
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: plot_clusters.m,v 1.7 2014/02/09 11:10:46 mechanoid Exp $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% рисуем точки кластеров второго уровня
%
% S  - результаты кластеризации
% X  - исходный набор точек
% q - качество
%
function retval = plot_clusters(X,S,q),
   pix_size='-S720,720';
   pix_font_size=7;

   Xc=S{1};
   C0=S{2};
   C1=S{3};

   szC0=size(C0,2) ; 
   szC1=size(C1,2) ; 
   szX=size(X,1);
   szXc=size(Xc,1);

   % цветовая палитра по числу кластеров второго уровня
   palette = jet(szC1) ;

   xm=ceil(max(max(X))) ; ax=[ 0 xm 0 xm ] ;
   clf; hold on; axis(ax);grid on; set(gca,'fontsize',pix_font_size) ; 

   for i = 1:szC1,
	  printf('%i/%i       \r',i,szC1);
	  c0i = C1{i} ;
	  plot_subclusters(X,Xc,C0,c0i,palette(i,:));
   endfor

   title(sprintf('points:%i, clusters: hight %i / low %i\nquality: hight %f / low %f',szX,szC1,szXc,q(1),q(2)));
   print('result/S.png','-dpng' ,pix_size) ;

   retval = 0 ;
endfunction


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval = plot_subclusters(X,Xc,C0,c0i,clr),

   for j=c0i, 
	  % центр подкластера
	  x=Xc(j,:);
	  plot( x(1,1), x(1,2), '*','color',clr ) ; 
	  plot( x(1,1), x(1,2), 'o','color',clr ) ;
	  % рисуем точки подкластера j
	  k=C0{j} ;
	  xk=X(k,:);
	  plot( xk(:,1), xk(:,2), '.','color',clr ) ; 
	  % рисуем оболочку кластера
	  plot_convhull(xk);
   endfor

   retval=0 ;
endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval = plot_convhull(X),
   sz=size(X,1) ;
   % рисуем оболочку кластера
   if sz>2,
	  kh = convhull(X(:,1),X(:,2)) ;
	  plot(X(kh,1), X(kh,2), '-r') ;
   else
	  plot(X(:,1), X(:,2), '-r') ;
   endif
   retval = 0 ;
endfunction


