%!octave 
%
%     FOREL
%      
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.6.4
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: plot_graph.m,v 1.1 2014/02/09 11:10:46 mechanoid Exp $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% рисуем граф кластеров второго уровня
%
% X  - исходный набор точек
% Xc - набор точек-центроидов кластеров первого уровня
% G  - матрица инциндентности графа, построенного на точках Xc
% r  - размер кластера первого уровня
% f  - номер картинки
%
function retval = plot_graph(X,Xc,G,r,f),
   pix_size='-S720,720';
   pix_font_size=7;

   xm=ceil(max(max(X))) ; ax=[ 0 xm 0 xm ] ;
   clf; hold on ; axis(ax) ; grid on; set(gca,'fontsize',pix_font_size);
   plot( X(:,1) , X(:,2) , '.g' ) ; 
   plot( Xc(:,1) , Xc(:,2) , '.r' ) ; 
   szXc = size(Xc,1) ;
   for i = 1:szXc,
	  printf('%i/%i       \r',i,szXc);
	  gi = find(G(i,:)) ;
	  for j = gi, plot( Xc( [i j] ,1) , Xc( [ i j ] , 2) , '-r' ) ; endfor
   endfor
   title(sprintf('points:%i, vertex:%i, range:%f',size(X,1),szXc,r)) ;
   print(sprintf('result/G%i.png',f),'-dpng',pix_size) ;
endfunction 
