%!octave 
%
%     KNP
%      
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.6.4
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: remove_long_edges.m,v 1.5 2014/02/09 11:32:20 mechanoid Exp mechanoid $

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% удалить k самых длинных рёбер из графа G
function retval=remove_long_edges(G,R,k),
   % количество рёбер графа
   cg=sum(sum(G))/2;
   if cg<k, 
	  retval = zeros(size(G,1)) ; 
	  return;
   endif

   % матрица (треугольная) растояний R
   % между связанными точками графа G
   RG = triu(R.*G ,1) ; 

   % ищем список пар точек с максимальными расстояниями
   % максимальные значения расстояний для каждой точки
   [ v i ] = max(RG) ; 
   
   % нумеруем максимумы для каждой точки
   szG = size(G,1) ;
   Gmax = [ v ; i ; 1:szG ]' ;
   
   % сортируем по возрастанию расстояния
   Gmax = sortrows(Gmax,1) ;
   
   % отбираем K самых длинных ребер
   sz=max( szG-k+1 , 1 ) ;
   Gmax(1:sz,:)=[] ;
   
   % собираем индексы
   i = Gmax(:,2) ;
   j = Gmax(:,3) ;
   
   % обнуляем нужные позиции матрицы инциндентности
   G(i,j) = 0 ;
   G(j,i) = 0 ;
   
   retval = G ;

endfunction

