%!octave 
%
%      
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.6.4
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: separate_clusters.m,v 1.5 2014/02/09 11:10:46 mechanoid Exp $



% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval = separate_clusters(G,Xc,X),
   szXc = size(Xc,1);

   % рассчитать расстояния между центройдами Xc и точками из X
   D=build_dist_matrix_centroids(X,Xc);

   % для каждой точки X найти ближайший центроид Xc
   [ md mi ] = min(D) ;

   % разобрать X по кластерам первого уровня С
   C0={}; z=[];
   for i=1:szXc,
      % выделить номера точек X, ближайших к центройду номер i
	  xi=find(mi==i) ;
	  C0(i)=[ xi ] ;
   endfor

   % конвертируем граф G из центройдов Xc
   % в структуру из номеров точек Xc
   C1=separate_clusters_knp(G) ;

   S={Xc,C0,C1} ; 

   save('-text','result/S.txt','S') ;

   retval=S ;
endfunction



