%!octave 
%
%      
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.6.4
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: separate_clusters_knp.m,v 1.1 2014/02/09 11:10:46 mechanoid Exp $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% группируем номера связных вершин графа G в структуру 
function retval = separate_clusters_knp(G),
   szG = size(G,1) ;
   % список номеров не обработанных центроидов (вершин графа G) 
   Ix = 1:szG ;
   szIx = size(Ix,2) ;

   C={} ; ci=1 ;

   while szIx>0,
	  % выбрать (случайный) номер центроида
      x = Ix(1) ;
      % обойти граф связанный с точкой номер x
	  I = read_tree(G,x,0) ;
      % сохранить номера вершин в структуре
	  C(ci) = I ; ci+=1 ;
	  % удалить обработанные вершины из рабочего списка
	  Ix = setdiff(Ix,I) ;
	  szIx = size(Ix,2) ;
   endwhile

   %save('-text','result/C.txt','C') ;

   retval = C ;

endfunction
